import java.net.*;
import java.io.*;

/* 
 * read input from user, and send it to server.
 * (the server should broadcast the message to all the clients).
 */
public class MyUDPBroadcastClient {
    public static void main(String[] args) throws Exception {

        // create a socket to send data.
        final DatagramSocket s = new DatagramSocket();

        // get IP address
        //  .. actually constructs a UDP packet, 
        //  .. and sends it to a DNS server
        //  .. which responds with the IP address
        //  .. for that host.
        InetAddress ip = InetAddress.getByName("localhost");
        int port = 12345;   // port where we're sending.

        (new Thread(
            new Runnable(){
                public void run(){
                    byte[] arr = new byte[2000];
                    DatagramPacket p;
                    for(;;){
                        // create a packet to accept recieved data into.
                        p = new DatagramPacket(arr,arr.length);
                        // wait (on socket) for the next packet.
                        try{
                            s.receive(p);
                            String pstr = new String(p.getData(),p.getOffset(),p.getLength());
                            pstr = ""+p.getAddress()+":"+p.getPort()+": "+pstr;
                            System.out.println(pstr);
                        }catch(Exception e){}
                    }
                }
            }
        )).start();


        // create reader (to read lines)
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));

        // loop for input lines.
        String line = br.readLine();
        while(line != null){
            line = line.trim();
            if(line.equalsIgnoreCase("exit")){
                System.exit(0);
            }

            // data bytes to send.
            byte[] ourOutData = line.getBytes();
            // create a package.
            DatagramPacket p = new DatagramPacket(ourOutData, ourOutData.length,ip,port);
            s.send(p);

            line = br.readLine();
        }
    }
}


