import java.net.*;
import java.util.*;

class ClientInfo {
    InetAddress ip;
    int port;
    long lastMsgTim;
    public ClientInfo(InetAddress ip,int port){
        this.ip = ip;
        this.port = port;
    }
}

public class MyUDPBroadcastServer {

    // server that keeps a list of currently 
    // responding clients.
    
    public static void main(String[] args) throws Exception {
        // create a server socket (on port, etc.)
        DatagramSocket s = new DatagramSocket(12345);
        
        Hashtable clients = new Hashtable();

        // data buffer for our packet.
        byte[] arr = new byte[2000];
        for(int pktcnt=0;;pktcnt++){
            // create a packet to write recieved data into.
            DatagramPacket p = new DatagramPacket(arr,arr.length);
            // wait (on socket) for the next packet.
            s.receive(p);

            // construct IP:port string (ie: key)
            String clientId = ""+p.getAddress()+":"+p.getPort();
            
            // find the client in our "database"
            ClientInfo ci = (ClientInfo)clients.get(clientId);
            if(ci == null){
                ci = new ClientInfo(p.getAddress(),p.getPort());
                clients.put(clientId,ci);
            }
            ci.lastMsgTim = System.currentTimeMillis();

            // loop for all other clients and forward
            // message to them.
            Enumeration en = clients.keys();
            while(en.hasMoreElements()){
                String key = (String)en.nextElement();
                if(key.equals(clientId))
                    continue;
                // find client in db.
                ci = (ClientInfo)clients.get(key);
                // check if client was heard from 
                // in last 60 seconds.
                if(System.currentTimeMillis() - ci.lastMsgTim > 60*1000){
                    clients.remove(key);
                    continue;
                }                
                p.setAddress(ci.ip);
                p.setPort(ci.port);
                s.send(p);
            }
        }
    }
}
