import java.net.*;

/* 
 * program to send 100 packets (current time) to some
 * server, and then quit.
 */
public class MyUDPTimeClient {
    public static void main(String[] args) throws Exception {
        // human readable string that we send.
        String ourStrData = "What time is it?";
        // data bytes to send.
        byte[] ourOutData = ourStrData.getBytes();
        // get IP address
        //  .. actually constructs a UDP packet, 
        //  .. and sends it to a DNS server
        //  .. which responds with the IP address
        //  .. for that host.
        InetAddress ip = InetAddress.getByName("localhost");
        int port = 12345;   // port where we're sending.
        // create a package.
        DatagramPacket p = new DatagramPacket(ourOutData, ourOutData.length,ip,port);

        // create a socket to send data.
        DatagramSocket s = new DatagramSocket();
        // send the packet.
        s.send(p);

        // if time server gets packet, then it will
        // resond with time... which we'll accept.
        
        byte[] arr = new byte[2000];
        // create a packet to accept recieved data into.
        p = new DatagramPacket(arr,arr.length);
        // wait (on socket) for the next packet.
        s.receive(p);

        String pstr = new String(p.getData(),p.getOffset(),p.getLength());
        System.out.println("p.getAddress: "+p.getAddress());
        System.out.println("p.getPort(): "+p.getPort());
        System.out.println("recieved: "+pstr);
        
        long timMillis = Long.parseLong(pstr,10);
        System.out.println("Time received from server: "+new java.util.Date(timMillis));
    }
}


